class MSBGame extends GameInfo
config;

#exec OBJ LOAD FILE=MovieSandboxMeshes.usx
#exec OBJ LOAD FILE=MovieSandboxTextures.utx


var name startStateName;

static function PrecacheGameStaticMeshes(LevelInfo myLevel)
{
super.PrecacheGameStaticMeshes(myLevel);
myLevel.AddPrecacheStaticMesh(StaticMesh'MoviesandboxMeshes.helperMeshes.CubeWhite');
}

static function PrecacheGameTextures(LevelInfo myLevel)
{
super.PrecacheGameTextures(myLevel);
myLevel.AddPrecacheMaterial(Material'MovieSandboxTextures.white');
}

event PlayerController Login(string Portal,string Options,out string Error)
{
    local NavigationPoint StartSpot;
    local PlayerController NewPlayer;

	Options = StripColor(Options);	// Strip out color Codes

    // Find a start spot.
    StartSpot = FindPlayerStart( None, 0, Portal );

    if( StartSpot == None )
    {
        Error = GameMessageClass.Default.FailedPlaceMessage;
        return None;
    }

    if ( PlayerControllerClass == None )
        PlayerControllerClass = class<PlayerController>(DynamicLoadObject(PlayerControllerClassName, class'Class'));

    NewPlayer = spawn(PlayerControllerClass,,,StartSpot.Location,StartSpot.Rotation);
    NewPlayer.StartSpot = StartSpot;

    // Init player's replication info
    NewPlayer.GameReplicationInfo = GameReplicationInfo;
    NewPlayer.GotoState(startStateName);
    Log(Options);

  	if(HasOption(Options,"LoadMSB"))
      {
      MSBController(NewPlayer).bInstantLoad=true;
      MSBController(NewPlayer).instantLevel=ParseOption(Options,"LoadMSB");
      }

    if(HasOption(Options,"InstantRun"))
      {
      Log("*********************************Running instantly!");
      MSBController(NewPlayer).bInstantRun=true;
      }

    return newPlayer;
}

defaultproperties
{
startStateName=MSBCode
HUDType="MSBCode.MSBSceneEditorHud"
PlayerControllerClassName="MSBCode.MSBController"

bLoggingGame=true
ScreenShotName="UT2004Thumbnails.DMShots"
DecoTextName="XGame.Deathmatch"
MapListType="XInterface.MapListDeathMatch"

TimeLimit=0
bChangeLevels=false
Acronym="MI"
MapPrefix="DM"
GameName="MovieSandbox"
Description="Make your own movies"
}

