class MSBHud extends HUD
config (MSBCode);

var MSBMouseOverlay MouseOverlay;
var MSBController M;

var() config array<String> MenuButtons;
var() array<MSBUserOverlay> UserOverlays;

var bool DrawOverlays;
var bool bStartMenu;

var MSBDepthOfFieldOverlay DoFOverlay;

var int xStart,
        yStart,
        xSpacing,
        ySpacing;

//-------------------------------------------------------
// first spawn mouse and connect to interaction class
// then spawn all buttons and add them
// then spawn the MSBDepthOfFieldOverlay
// the add mouse on top
//-------------------------------------------------------
event PostBeginPlay()
{
super.PostBeginPlay();
M=MSBController(Level.GetLocalPlayerController());
MouseOverlay=Spawn(class'MSBMouseOverlay');
if (bStartMenu)
  spawnBaseMenu();
DofOverlay=Spawn(class'MSBDepthOfFieldOverlay');
AddHudOverlay(MouseOverlay);
}

function spawnBaseMenu()
{
local MSBGuiOverlay buttonOverlay;
local class<MSBGuiOverlay> ButtonClass;
local int i;

for (i=0;i<MenuButtons.length;i++)
  {
  ButtonClass = class<MSBGuiOverlay>(DynamicLoadObject(MenuButtons[i], class'Class'));
  buttonOverlay=Spawn(ButtonClass,self,,M.Location);
  if (buttonOverlay.xPosRel==0)
    {
    buttonOverlay.xPosRel=xStart;
    if (i==0)
      buttonOverlay.yPosRel=yStart;
    else
      buttonOverlay.yPosRel=yStart+(buttonOverlay.heightRel+ySpacing)*i;;
    }
  buttonOverlay.Mouse=MouseOverlay;
  AddHudOverlay(buttonOverlay);
  }
Log("Spawning Base Menu...");
}

simulated event PostRender(Canvas C)
{
if (M!=None)
  {
  M.screenX=C.ClipX;
  M.screenY=C.ClipY;

  C.SetDrawColor(255,255,255);
  C.DrawText("Debug:"@M.debugString);
  C.DrawText("Keypress:"@M.debugKeyString);
  }
adjustButtonLocations();
MouseOverlay.hudTargetActor=None;
}

function adjustButtonLocations()
{
local int i;
for (i=1;i<MenuButtons.length;i++)
  {
  if (Overlays.length>i && Overlays[i]!=None && Overlays[i].IsA('MSBGuiOverlay') && MSBGuiOverlay(Overlays[i]).bMainMenu)
    {
    MSBGuiOverlay(Overlays[i]).xPosRel=xStart+(MSBGuiOverlay(Overlays[i]).widthRel*xSpacing)*i;
    MSBGuiOverlay(Overlays[i]).yPosRel=yStart+(MSBGuiOverlay(Overlays[i]).heightRel*ySpacing)*i;

    //borders
    if (MSBGuiOverlay(Overlays[i]).yPosRel+MSBGuiOverlay(Overlays[i]).heightRel>768)
      MSBGuiOverlay(Overlays[i]).yPosRel=768-MSBGuiOverlay(Overlays[i]).heightRel;

    if (MSBGuiOverlay(Overlays[i]).xPosRel+MSBGuiOverlay(Overlays[i]).widthRel>1024)
      MSBGuiOverlay(Overlays[i]).xPosRel=1024-MSBGuiOverlay(Overlays[i]).widthRel;
    }
  }
}

defaultproperties
{
xStart=0
yStart=16
ySpacing=1.5
xSpacing=0
drawOverlays=true
bStartMenu=true
}
