//-----------------------------------------------------------
//  A ListButton Spawns a number of SubButtons
//  just like in a Menu.
//  Once another Button is triggered, the Menu is being removed.
//
//  Copyright 2005 Friedrich Kirschner
//-----------------------------------------------------------
class MSBListButton extends MSBGuiOverlay
config(MSBButtonConfig);

var config array<String> ButtonList;
var class<MSBGuiOverlay> ButtonClass;
var array<MSBGuiOverlay> ListButton;
var MSBScrollBar scrollBar;
var Canvas Canv;

//TODO:
var bool bRainbow;                                   //sets Listbuttons to a random color

//Buttonlist page system:
var int liststart, listend, maxListSize;
var int listOrientation;                             //1=left
                                                     //2=bottom
                                                     //3=right
                                                     //4=top

function LeftBtn(Canvas C)                      //spawns subButtons
{
local int i;
super.LeftBtn(C);

Canv=C;
if(liststart==0)
  listend=maxListSize;
// revisit button distribution...
createButtons();

//positioning the scrollbar and stuff
if(ButtonList.Length>maxListSize)
  {
  scrollBar=Spawn(class'MSBScrollBar',self);
  scrollBar.Parent=self;
  scrollbar.sliderValue=float(maxListSize)/float(buttonList.Length);
  scrollbar.heightRel=maxListSize*(ListButton[i].heightRel+1);
  scrollBar.SubLevel=SubLevel+1;
  positionScrollBar(C);
  }
}

function createButtons()
{
local int i, j;
for (i=liststart;i<listend;i++)
  {
  if (i<ButtonList.length && ButtonList[i]!="" && ButtonList[i]!="None")
    {
    ButtonClass = class<MSBGuiOverlay>(DynamicLoadObject(ButtonList[i], class'Class'));
    ListButton[j]=Spawn(ButtonClass,self,,M.Location);
    ListButton[j].SubLevel=SubLevel+1;
    j++;
    }
  }

for (i=0;i<ListButton.length;i++)
  if (ListButton[i]!=None)
    positionButton(Canv,i,xposRel,yPosRel);
}

function positionScrollBar(Canvas C, optional float x, optional float y)
{
if(listOrientation==1)
  {
  scrollBar.xPos=xpos+width+ListButton[0].width;
  scrollBar.yPos=yPos;
  }
if(listOrientation==2)
  {
  scrollBar.xPos=xpos+ListButton[ListButton.length-1].width;
  scrollBar.yPos=ListButton[ListButton.length-1].yPos;
  }
}

function positionButton(Canvas C, int i, optional float x, optional float y)
{
if(listOrientation==1)
  positionButtonLeft(C,i,xPos,yPos);

if(listOrientation==2)
  positionButtonBottom(C,i,xPos,yPos);
}

function positionButtonLeft(Canvas C,int i, optional float x, optional float y)
{
if (ListButton[i].height<60)
  ListButton[i].xPos=x+width;
else
  {
  ListButton[i].xPos=x-16 -2*width;
  if (Listbutton[i].xPos<C.ClipX)
    ListButton[i].xPos=x+16+2*width;
  }

if (i>0)                      //horizontal alignment
  ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+1;
else
  ListButton[i].yPos=y;
}

function positionButtonBottom(Canvas C,int i, optional float x, optional float y)
{
ListButton[i].xPos=x;

if (i>0)                      //vertical alignment
  ListButton[i].yPos=ListButton[i-1].ypos-(ListButton[i].height+1);
else
  ListButton[i].yPos=y-(ListButton[i].height+1);
}

function Trigger(Actor Other, Pawn EventInstigator)
{
if (Other==scrollBar)
  {
  listend=scrollBar.sliderValue*float(ButtonList.length);
  if(listend<maxListSize)
    listend=maxListSize;
  liststart=listend-MaxListsize;
  removeButtons();
  createButtons();
  }
}

function removeButtons()
{
local int i;
for (i=0;i<ListButton.length;i++)
  if(ListButton[i]!=None)
    ListButton[i].Destroy();
}



DefaultProperties
{
tooltip="Click for more Options"
maxListSize=10
listOrientation=1
}
