//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBMiniMap extends MSBGUIOverlay;

var float scaleFactor,
          oldXPos,oldYPos,
          rectxPos,rectyPos;

var color rectColor, selectedColor;

var bool hasClickedAgain;


function initButton(Canvas C)
{
local float xDist,yDist;
xDist=Mouse.xPos-oldXPos;
yDist=Mouse.yPos-oldYPos;

oldXPos=Mouse.xPos;
oldYPos=Mouse.yPos;

if (bDragged)
  {
  M.shiftLeft(xDist*2/scalefactor);
  M.shiftUp(yDist*2/scalefactor);
  }
}

function Render(Canvas C)
{
relativeWidthHeight();

initButton(C);
bOver=checkover(Mouse.xpos,Mouse.ypos);
rectColor=default.rectColor;

if (Mouse.btnOneDown && bOver)
    LeftBtn(C);
else
    bDragged=false;

DrawMiniMap(C);
}

function LeftBtn(Canvas C)
{
rectColor=selectedColor;
oldXPos=Mouse.xPos;
oldYPos=Mouse.yPos;
bDragged=true;
}

function DrawMiniMap(Canvas C)
{
local int i;
//draw rectangle
C.SetPos(xPos-1, yPos+height);
C.DrawLine(0,height);
C.DrawLine(3,width+1);
C.SetPos(xPos+width, yPos);
C.DrawLine(1,height);
C.DrawLine(2,width+1);


//draw nodes and stuff
for (i=0;i<M.LevelNodes.length;i++)
  if (M.LevelNodes[i]!=None)
    DrawNode(M.LevelNodes[i], C);

for (i=0;i<M.LevelMSBScriptNodes.length;i++)
  if (M.LevelMSBScriptNodes[i]!=None)
    DrawNode(M.LevelMSBScriptNodes[i],C);

for (i=0;i<M.Levelcontainers.length;i++)
  if (M.Levelcontainers[i]!=None)
    DrawNode(M.Levelcontainers[i], C);
}

function MouseOver(Canvas C);

function DrawNode(MSBGuiOverlay myIcon, Canvas C)
{
local float myX,myY,
            myWidth,myHeight,
            screenWidth,screenHeight,
            scrollX,scrollY;

//make relative
scrollX=M.scrollLeft*scaleFactor*width/C.ClipX;
scrollY=M.scrollUp*scaleFactor*height/C.ClipY;

myX=myIcon.xPos*scaleFactor*width/C.ClipX+scrollX;
myY=myIcon.yPos*scaleFactor*height/C.ClipY+scrollY;

myWidth=myIcon.Width*scaleFactor*width/C.ClipX;
myHeight=myIcon.Height*scaleFactor*height/C.ClipY;

screenWidth=C.ClipX*scalefactor*width/C.ClipX;
screenHeight=C.ClipY*scalefactor*height/C.ClipY;

C.SetPos(xPos+myX, yPos+myY);
C.SetDrawColor(myIcon.col.R,myIcon.col.G,myIcon.col.B);
C.DrawTile(myIcon.Mat,myWidth,myHeight,0,0,8,8);

//draw current Screen rectangle
C.SetDrawColor(rectColor.R,rectColor.G,rectColor.B);
C.SetPos(xPos+scrollX, yPos+1+scrollY);
C.DrawLine(1,screenheight);
C.DrawLine(3,screenwidth);
C.SetPos(xPos+screenwidth+scrollX, yPos+screenheight+scrollY);
C.DrawLine(0,screenheight);
C.DrawLine(2,screenwidth);

}

DefaultProperties
{
widthRel=320
heightRel=240
xPosRel=700;
yPosRel=4;
col=(R=64,G=64,B=64)
scaleFactor=0.5
selectedColor=(R=255,G=0,B=0)
rectColor=(R=0,G=255,B=0)
}
