class MSBNodeOutButton extends MSBTwoStepButton;

var MSBNodeInButton ChildNode;
var MSBNodeButton myNode;
var MSBScriptNodeButton myScript;

var color lineColor;
var int lineXLength;
var float lineYLength;

var bool drawLink;       //NodeButton collapsing

var float widthExRel,
          heightExRel,
          widthRelBase,
          widthEx,
          heightEx;

function LeftBtn(Canvas C)
{
super.LeftBtn(C);
MSBSceneEditorHud(M.myHUD).bOut=true;
}

function LeftBtnFinished(Canvas C)
{
super.LeftBtnFinished(C);
if (Mouse.hudTargetActor!=None && Mouse.hudTargetActor.IsA('MSBNodeInButton'))
  {
  Log("found NodeIn");
  ClearLinks();
  ChildNode=MSBNodeInButton(Mouse.hudTargetActor);
  ChildNode.ClearLinks();
  ChildNode.ParentNode=self;
  if (myNode!=None)
    myNode.Order.OurNextScript=ChildNode.myNode.Order;
  else
    myScript.Order.OurNextScript=ChildNode.myNode.Order;
  }
if (Mouse.hudTargetActor==None)
  ClearLinks();
}


function initButton(Canvas C)
{
if (myNode!=None)
  {
  xPos=myNode.xPos+myNode.width-width;
  yPos=myNode.yPos+myNode.height;
  }
else
  {
  xPos=myScript.xPos+myScript.width-width;
  yPos=myScript.yPos+myScript.height;
  }
super.initButton(C);
if (!bOver && widthRel>widthRelBase)
  {
  widthRel-=4;
  heightRel-=4;
  }
}

function MouseOver(Canvas C)
{
super.MouseOver(C);
if (widthRel<widthEx)
  widthRel+=4;
if (heightRel<heightEx)
  heightRel+=4;
}


function Render(Canvas C)
{
local float hLength,
            hSplitPos,
            vSplitPos,
            vLength;

if (myNode!=None)
 {
 if(myNode.bContained)
  return;
 }
else if (myScript.bContained)
  return;

if (widthExRel>0)
  {
  widthEx=widthExRel*C.ClipY/768;
  heightEx=heightExRel*C.ClipY/768;
  }

super.Render(C);

if (hasClicked)
  {
  hLength=Mouse.xPos-(xPos+width);
  hSplitPos=hLength/2+xPos+width;
  vLength=Mouse.yPos-(yPos+height/2);
  vSplitPos=Mouse.yPos;

  C.SetDrawColor(255,0,0);
  C.SetPos(xpos+width,ypos+height/2);
  C.DrawRect(Texture'engine.WhiteSquareTexture', hLength/2, 1);

  C.SetPos(hSplitPos,ypos+height/2);
  C.DrawRect(Texture'engine.WhiteSquareTexture', 1, vLength);

  C.SetPos(hSplitPos,vSplitPos);
  C.DrawRect(Texture'engine.WhiteSquareTexture', hLength/2, 1);
  C.SetDrawColor(col.R,col.G,col.B);

  C.SetPos(0,0);
  C.DrawText("hudTarget:"@Mouse.hudtargetActor);
  }


if (ChildNode!=None && drawLink)  //draw Link
  {
  hLength=ChildNode.xPos+ChildNode.width/2-(xPos+width);
  hSplitPos=hLength/2+xPos+width;
  vLength=ChildNode.yPos+ChildNode.height/2-(yPos+height/2);
  vSplitPos=ChildNode.yPos+ChildNode.height/2;

  C.SetDrawColor(lineColor.R,lineColor.G,lineColor.B);
  C.SetPos(xpos+width,ypos+height/2);
  C.DrawRect(Texture'engine.WhiteSquareTexture', hLength/2, 1);

  C.SetPos(hSplitPos,ypos+height/2);
  C.DrawRect(Texture'engine.WhiteSquareTexture', 1, vLength);

  C.SetPos(hSplitPos,vSplitPos);
  C.DrawRect(Texture'engine.WhiteSquareTexture', hLength/2, 1);
  C.SetDrawColor(col.R,col.G,col.B);
  }
}


function ClearLinks()
{
if (ChildNode!=None)
  {
  ChildNode.ParentNode=None;
  if (myNode!=None)
    myNode.Order.OurNextScript=None;
  else
    myScript.Order.OurNextScript=None;
  ChildNode=None;
  }
}


defaultproperties
{
drawLink=true
tooltip1=""
tooltip2=""
Mat=Texture'MoviesandboxTextures.icon_nodeOut'
widthRel=20
heightRel=20
widthRelBase=16
widthExRel=28
heightExRel=28
lineColor=(R=200,G=200,B=200,A=255)
}
