//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPropertyButtonComplex extends MSBPropertyButton;

var array<String> ButtonList;
var array<String> ButtonName;
var array<String> ButtonProperty;
var class<MSBGuiOverlay> ButtonClass;
var array<MSBGuiOverlay> ListButton;
var bool bPassOnParent;

var MSBScrollBar scrollBar;
var Canvas Canv;


var int listOrientation;                             //1=left
                                                     //2=bottom
                                                     //3=right
                                                     //4=top
//Buttonlist page system:
var int maxListSize,liststart,listend;

function fillButtonList();

function LeftBtn(Canvas C)
{
local int i;
super.LeftBtn(C);

fillButtonList();

Canv=C;
if(liststart==0)
  listend=maxListSize;
// revisit button distribution...
createButtons();

//positioning the scrollbar and stuff
if(ButtonList.Length>maxListSize)
  {
  Log("bigger List, we need a scrollbar..."@ButtonList.length@maxListSize);
  scrollBar=Spawn(class'MSBScrollBar',self);
  scrollBar.Parent=self;
  scrollbar.sliderValue=float(maxListSize)/float(buttonList.Length);
  scrollbar.heightRel=maxListSize*(ListButton[i].heightRel+1);
  scrollBar.SubLevel=SubLevel+1;
  positionScrollBar(C);
  }
LeftBtnFinished(C);
}

function createButtons()
{
local int i, j;
local MSBPropertyButton prop;
for (i=liststart;i<listend;i++)
  {
  if (i<ButtonList.length && ButtonList[i]!="" && ButtonList[i]!="None")
    {
    ButtonClass = class<MSBGuiOverlay>(DynamicLoadObject(ButtonList[i], class'Class'));
    ListButton[j]=Spawn(ButtonClass,self,,M.Location);
    prop=MSBPropertyButton(ListButton[j]);
    prop.BtnName=ButtonName[i];
    prop.Property=ButtonProperty[i];
    ListButton[j].SubLevel=SubLevel+1;
    j++;
    }
  }
for (i=0;i<ListButton.length;i++)
  if (ListButton[i]!=None)
    positionButton(Canv,i,xposRel,yPosRel);
}

function positionScrollBar(Canvas C, optional float x, optional float y)
{
if(listOrientation==1)
  {
  scrollBar.xPos=xpos+width+ListButton[0].width;
  scrollBar.yPos=yPos;
  }
if(listOrientation==2)
  {
  if (SubLevel>0)
    scrollBar.xPos=xpos+width+ListButton[ListButton.length-1].width;
  else
    scrollBar.xPos=xpos+ListButton[ListButton.length-1].width;
  scrollBar.yPos=ListButton[ListButton.length-1].yPos;
  }
}

function MouseOver(Canvas C)
{
super.MouseOver(C);
C.SetPos(xpos+width,ypos);
if (Parent!=None && Parent.IsA('MSBNodeButton'))
  C.DrawText(MSBNodeButton(Parent).Order.GetPropertyText(Property));
}

function positionButton(Canvas C, int i, optional float x, optional float y)
{
if(listOrientation==1)
  positionButtonLeft(C,i,xPos,yPos);

if(listOrientation==2)
  if(SubLevel>0)
    positionButtonBottom(C,i,xPos+width,yPos);
  else
    positionButtonBottom(C,i,xPos,yPos);
}

function positionButtonLeft(Canvas C,int i, optional float x, optional float y)
{
if (ListButton[i].height<60)
  ListButton[i].xPos=x+width;
else
  {
  ListButton[i].xPos=x-16 -2*width;
  if (Listbutton[i].xPos<C.ClipX)
    ListButton[i].xPos=x+16+2*width;
  }

if (i>0)                      //horizontal alignment
  ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+1;
else
  ListButton[i].yPos=y;
}

function positionButtonBottom(Canvas C,int i, optional float x, optional float y)
{
ListButton[i].xPos=x;

if (i>0)                      //vertical alignment
  ListButton[i].yPos=ListButton[i-1].ypos-(ListButton[i].height+1);
else
  ListButton[i].yPos=y-(ListButton[i].height+1);
}

function Trigger(Actor Other, Pawn EventInstigator)
{
if (Other==scrollBar)
  {
  listend=scrollBar.sliderValue*float(ButtonList.length);
  if(listend<maxListSize)
    listend=maxListSize;
  liststart=listend-MaxListsize;
  removeButtons();
  createButtons();
  }
}

function removeButtons()
{
local int i;
for (i=0;i<ListButton.length;i++)
  if(ListButton[i]!=None)
    ListButton[i].Destroy();
}


DefaultProperties
{
Col=(R=128,G=64,B=64)
maxListSize=8
bPassOnParent=false
listOrientation=1
}
