class MSBActor extends Actor;

var array<String> ButtonList;
var array<String> Properties;
var array<String> ButtonMat;
var vector initialLocation;
var rotator initialRotation;
var EPhysics oldPhysics;
var Actor AttachedTo;
var string content;
var array<MSBKeyFrame> Keys;

var bool bDisplayed;  //seperates the control objects from the props

//Every Actor can be controlled by an Input device sending data to its channel
var bool bInputControlled;
var string InputControlClassName;
var Actor MSBInputControl;
var int UdpPadCh;


function initialize();

function LoadProp()
{
local Material newTex;

newTex=Material(DynamicLoadObject(content, class'Material'));
if (newTex!=None)
  {
  SetDrawType(DT_Sprite);
  Texture=newTex;
  }
SetStaticMesh(StaticMesh(DynamicLoadObject(content, class'StaticMesh')));
if (StaticMesh!=None)
  {
  Skins.Remove(0,Skins.length);
  SetDrawType(DT_StaticMesh);
  }
Log("Loading content:"@content);
}

function RunMovie()
{
oldPhysics=Physics;
initialLocation=Location;
initialRotation=Rotation;
// Log("MSActor->RunMovie->Location:"@name@initialLocation);
}

function StopMovie();

function Reset()
{
super.Reset();
if (attachedTo==None)
  {
  SetPhysics(PHYS_None);
  SetLocation(initialLocation);
  SetRotation(initialRotation);
  SetPhysics(oldPhysics);
  }
}

function clearActor();

function SetDebug();

defaultproperties
{
Skins(0)=Material'MovieSandboxTextures.white'

ButtonList(0)="MSBPropertyButtons.MSBPropertyButtonMove"
Properties(0)="Dummy"
ButtonMat(0)="MoviesandboxTextures.icon_move"

ButtonList(1)="MSBPropertyButtons.MSBPropertyButtonRotate"
Properties(1)="Dummy"
ButtonMat(1)="MoviesandboxTextures.icon_rotate"

ButtonList(2)="MSBPropertyButtons.MSBPropertyButtonScale"
Properties(2)="Dummy"
ButtonMat(2)="MoviesandboxTextures.icon_size"

ButtonList(3)="MSBPropertyButtons.MSBPropertyButtonCreateKeyFrame"
Properties(3)="Dummy"
ButtonMat(3)="MoviesandboxTextures.icon_key"

ButtonList(4)="MSBPropertyButtons.MSBPropertyButtonAdvancedProps"
Properties(4)="Dummy"
ButtonMat(4)="MoviesandboxTextures.icon_advanced"

bDisplayed=true

bStatic=false
bNoDelete=false
bHidden=false
bMovable=true

bDirectional=True

//CollisionRadius=16.0
//CollisionHeight=16.0

bUseCylinderCollision=false
bUseCollisionStaticMesh=true
bCollideActors=True
bBlockActors=False
bCollideWorld=True
bProjTarget=True
bBlockPlayers=false
Texture=S_Actor
}
