//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBGametrakInputControl extends Actor;

const bufferlength=6;

var MSBActor ControlActor;
var MSBUdpLink udpLink;
var() float pointDist, moveScale;  //real World distance between the two Gametrak Points

var vector locBuffer[bufferlength];
var rotator rotBuffer[bufferlength];

event PostBeginPlay()
{
super.PostBeginPlay();
if (Owner.IsA('MSBActor'))
  ControlActor=MSBActor(Owner);
Log("Inputcontrol connected to:"@ControlActor);
}

event Trigger(Actor Other,Pawn eventInstigator)
{
local float pOneLength, pTwoLength, data;
local rotator offset, pOneRot, pTwoRot, bufferedRotation;
local vector pOne, pTwo, distance, bufferedLocation;
local int i;

if (Other.isA('MSBGuiOverlay'))
  {
  if (udpLink!=None)
    udpLink.destroy();
  udpLink = spawn (class'MSBUdpLink',self);
  udpLink.InitUdpLink(31840+ControlActor.udpPadCh);
  }

if (Other.IsA('MSBUdpLink') && ControlActor.bHidden)
  {
  offset.Pitch=16384;

  // *********************************************************  First Point
  data=(UdpLink.byteData[0] << 8)+ UdpLink.byteData[1] - 32768;
  data=(data/32768)*5461;
  pOneRot.Yaw=data;

  data=(UdpLink.byteData[2] << 8)+ UdpLink.byteData[3] - 32768;
  data=(data/32768)*5461;
  pOneRot.Pitch=-data;

  pOneLength=65536 -((UdpLink.byteData[4] << 8) + UdpLink.byteData[5]) ;
  pOne=vector(pOneRot)*((pOneLength/moveScale));
  pOne=pOne >> offset;

  // *********************************************************  Second Point
  data=(UdpLink.byteData[6] << 8)+ UdpLink.byteData[7] - 32767;
  data=(data/32768)*5461;
  pTwoRot.Yaw=data;

  data=(UdpLink.byteData[8] << 8)+ UdpLink.byteData[9] - 32767;
  data=(data/32768)*5461;
  pTwoRot.Pitch=-data;

  pTwoLength=65536 -((udpLink.byteData[10] << 8) + udpLink.byteData[11]) ;
  pTwo=vector(pTwoRot)*pTwoLength/moveScale;
  pTwo=pTwo >> offset;

  pTwo.Y+=pointDist*32/moveScale;
  distance=pTwo-pOne;

  offset.Pitch=0;
  offset.Yaw=16384;

  distance=distance << offset;

  // *********************************************************  buffering

  //shift buffer
  for (i=bufferlength-1;i>0;i--)
    {
    locBuffer[i]=locBuffer[i-1];
    rotBuffer[i]=rotBuffer[i-1];
    }

  //update buffer
  locBuffer[0]=pOne;
  rotBuffer[0]=rotator(distance);

  //calculate buffered values
  for (i=0;i<bufferlength;i++)
    {
    bufferedLocation+=locBuffer[i];
    bufferedRotation+=rotBuffer[i];
    }
  bufferedLocation=bufferedLocation/bufferlength;
  bufferedRotation=bufferedRotation/bufferlength;

  //apply Buffered values
  ControlActor.SetLocation(ControlActor.initialLocation+bufferedLocation);
  ControlActor.SetRotation(ControlActor.initialRotation+bufferedRotation);
  }
}

DefaultProperties
{
pointDist=64
moveScale=64
bHidden=true
}
