//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBProp extends MSBActor;

struct PropPart
{
var MSBMasterBlock Bone;
var array<MSBsimpleBlock> Blocks;
};

var array<PropPart> Parts;
var string PropName;

function LoadProp()
{
local MSBBlockCloud cloud;
Log(content);
cloud=Level.Game.LoadDataObject(class'MSBBlockCloud',content,"MSBVoxPart_"$content);
if (cloud.BoneRelLocation.length>0)
  LoadComplexProp(cloud);
else
  LoadSimpleProp(cloud);
}

//****************************************************************************
// this is for props with more than one "bone"
// currently not implemented!

function LoadComplexProp(MSBBlockCloud cloud)
{
local int pnum, bnum,i;

for (pnum=0;pnum<cloud.BoneRelLocation.length;pnum++)
  {
  Parts.Insert(Parts.Length,1);
  Parts[pnum].Bone= Spawn(class'MSBMasterBlock',self,,Location);
  Parts[pnum].Bone.SetRelativeRotation(cloud.BoneRelRotation[pnum]);
  for(bnum=0;bnum<cloud.BlockRelLocation.length;bnum++)
    {
    if (cloud.BoneNumber[bnum]==pnum)
      {
      Parts[pnum].Blocks[i]=spawn(class'MSBsimpleBlock');
      Parts[pnum].Blocks[i].Master=Parts[pnum].Bone;

      Parts[pnum].Blocks[i].Skins[0]=new() class'ColorModifier';
      ColorModifier(Parts[pnum].Blocks[i].Skins[0]).Color=cloud.Col[bnum];
      ColorModifier(Parts[pnum].Blocks[i].Skins[0]).Material=Skins[0];

      Parts[pnum].Bone.AttachToBone(Parts[pnum].Blocks[i],'');
      Parts[pnum].Blocks[i].SetRelativeLocation(cloud.BlockRelLocation[bnum]);
      i++;
      }
    }
  Parts[pnum].Bone.SetDrawType(DT_None);
  Parts[pnum].Bone.SetCollision(false,false,false);
  }
Log("Loading coomplex!");
}

//****************************************************************************
// this is for props with one "bone"
// the standard Props to be created in the Voxeleditor

function LoadSimpleProp(MSBBlockCloud cloud)
{
local int i,sps;
local class<MSBVoxelShader> shaderclass;

Log("loading a simple Prop");
Parts.Insert(0,1);
Parts[0].Bone=Spawn(class'MSBMasterBlock',self,,Location,Rotation);
Parts[0].Bone.BoneNumber=-1;
for(i=0;i<cloud.BlockRelLocation.length;i++)
  {
  Parts[0].Blocks[i]=spawn(class'MSBsimpleBlock');
//  Parts[0].Blocks[i].bNoRotate=true;
  Parts[0].Blocks[i].Master=Parts[0].Bone;
  Parts[0].Blocks[i].Skins[0]=new() class'ColorModifier';
  ColorModifier(Parts[0].Blocks[i].Skins[0]).Color=cloud.Col[i];
  ColorModifier(Parts[0].Blocks[i].Skins[0]).Material=Skins[0];

  Parts[0].Bone.AttachToBone(Parts[0].Blocks[i],'');
  Parts[0].Blocks[i].SetRelativeLocation(cloud.BlockRelLocation[i]>>Rotation);
  Parts[0].Blocks[i].SetDrawScale(cloud.drawScale[i]);
  Parts[0].Blocks[i].initialDrawScale=cloud.drawScale[i];

  if (cloud.blockShader[i]!="")
    {
    shaderClass=class<MSBVoxelShader>(DynamicLoadObject(cloud.blockShader[i],class'Class'));
    Parts[0].Blocks[i].shader= new shaderClass;
    Parts[0].Blocks[i].shader.Parent=Parts[0].Blocks[i];
    Parts[0].Blocks[i].shader.originalDrawScale3D=Parts[0].Blocks[i].DrawScale3D;

    for (sps=0;sps<Parts[0].Blocks[i].shader.Properties.length;sps++)
      Parts[0].Blocks[i].shader.SetPropertyText(Parts[0].Blocks[i].shader.Properties[sps],cloud.blockShaderValues[sps]);
    }
  }
Parts[0].Bone.SetDrawType(DT_None);
Parts[0].Bone.SetCollision(false,false,false);

Log("Loading simple!");
}

function clearActor()
{
local int i;
Log("cleaning out"@name);
Parts[0].Bone.clearBlocks();
//total bescheuert aber is nochmal referenziert
for (i=0;i<Parts[0].blocks.length;i++)
  Parts[0].Blocks[i].Destroy();
Parts[0].Bone.Destroy();
}

DefaultProperties
{
DrawType=DT_None
}
