//-----------------------------------------------------------
// A completely set-up face block - was used for Bob Block
//-----------------------------------------------------------
class MSBVoxelFace extends MSBsimpleBlock;

//***************************************************************************
// SkinSwapping
var string Head, Eyes, Eyebrows, Mask, MouthOpen, MaskMouthOpen;

var Material MatHead;
var Material MatMask;
var Material MatEyes;
var Material MatEyeBrows;
var Material MatMouthOpen;
var Material MatMaskMouthOpen;
var TexScaler moveEyes;
var TexScaler moveBrows;
var Combiner EyesAndHead;
var Combiner HeadAndBrows;
var Shader finishedHead;

var float eyeAmp, browAmp, MouthTime;
// todo: cleanup after destroy!
event PostBeginPlay()
{
super.PostBeginPlay();
iniSkinSwap();
}

function Tick(float DeltaTime)
{
super.Tick(DeltaTime);

//Bob Block specific!
if (Skins[0]!=None)
  Skins[0]=None;
}

event mimic(int eyeX,int eyeY,int browX,int browY)
{
if (moveEyes!=None)
  {
  moveEyes.UOffset=eyeX*eyeAmp;
  moveEyes.VOffset=eyeY*eyeAmp;
  }
if (moveBrows!=None)
  {
  moveBrows.UOffset=browX*browAmp;
  moveBrows.VOffset=browY*browAmp;
  }
}

event talk()
{
if (EyesAndHead.Material2!=MatMouthOpen)
  {
  EyesAndHead.Material2=MatMouthOpen;
  EyesAndHead.Mask=MatMouthOpen;
  finishedHead.Opacity=MatMaskMouthOpen;
  }
SetTimer(MouthTime,false);
}

function Timer()
{
EyesAndHead.Material2=MatHead;
EyesAndHead.Mask=MatHead;
finishedHead.Opacity=MatMask;
Texture(MatMouthOpen).AnimCurrent=texture(MatMouthOpen);
texture(MatMouthOpen).PrimeCount=0;
texture(MatMouthOpen).PrimeCurrent=0;
}

event iniSkinSwap()
{
Log("init Pawn Skinswapping");

MatHead=Material(DynamicLoadObject(Head,class'Material',true));
MatMask=Material(DynamicLoadObject(Mask,class'Material',true));
MatMouthOpen=Material(DynamicLoadObject(MouthOpen,class'Material',true));
MatMaskMouthOpen=Material(DynamicLoadObject(MaskMouthOpen,class'Material',true));
MatEyes=Material(DynamicLoadObject(Eyes,class'Material',true));
MatEyeBrows=Material(DynamicLoadObject(Eyebrows,class'Material',true));

if (moveEyes==None)
  moveEyes=new class'TexScaler';
moveEyes.Material=MatEyes;

if (moveBrows==None)
  moveBrows=new class'TexScaler';
moveBrows.Material=MatEyeBrows;

if (EyesAndHead==None)
  EyesAndHead=new class'Combiner';
EyesAndHead.Material1=moveEyes;
EyesAndHead.Material2=MatHead;
EyesAndHead.Mask=MatHead;
EyesAndHead.CombineOperation=CO_AlphaBlend_With_Mask;

if (HeadAndBrows==None)
  HeadAndBrows=new class'Combiner';
HeadAndBrows.Material1=moveBrows;
HeadAndBrows.Material2=EyesAndHead;
HeadAndBrows.Mask=moveBrows;
HeadAndBrows.InvertMask=true;
HeadAndBrows.CombineOperation=CO_AlphaBlend_With_Mask;

if (finishedHead==None)
  finishedHead=new class'Shader';
finishedHead.Diffuse=HeadAndBrows;
finishedHead.Opacity=MatMask;

Skins[1]=finishedHead;
RepSkin=finishedHead;
}

DefaultProperties
{
drawscale=1
MouthTime=0.3
eyeAmp=1
browAmp=1
StaticMesh=StaticMesh'MoviesandboxMeshes.helperMeshes.CubeWhite'
}
