//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBVoxelPawn extends MSBPawn;

var vector MasterSize;
var array<MSBMasterBlock> Blocks;
var array<MSBsimpleBlock> MSBFaceBlock;                      //can mimic and talk

event PostBeginPlay()
{
super.PostBeginPlay();
setMSBMasterBlocks();
}

// *******************************************************************************
// Lipsyncing
// *******************************************************************************

function Talk()
{
local int i;

Log("Talking!");

for (i=0;i<MSBFaceBlock.length;i++)
  if (MSBFaceBlock[i]!=None)
    MSBFaceBlock[i].Talk();
}

function Mimic()
{
local int i;

super.Mimic();
for (i=0;i<MSBFaceBlock.length;i++)
  if (MSBFaceBlock[i]!=None)
    MSBFaceBlock[i].Mimic(eyeX, eyeY, browX, browY);
}

// *******************************************************************************
// Loading Voxels and cleaning up
// *******************************************************************************
function LoadCharacter()
{
LoadCharacterOne();
SetTimer(1,false);
}

function Timer()
{
LoadCharacterTwo();
}

function LoadCharacterOne()
{
local MSBVoxelCharacterSave char;
local int bone;
local MSBMasterBlock Master;

char=Level.Game.LoadDataObject(class'MSBVoxelCharacterSave',content,"MSBVoxChar_"$content);
for(bone=0;bone<char.Parts.length;bone++)
  {
    Master=Blocks[bone];
    if (Master!=None)
      {
      //get rid of old blocks
      Master.clearBlocks();
      Master.E=Spawn(class'MSBEmitter',Master);
      Master.E.P.SpawnParticle(char.Parts[bone].Col.length);
      Master.SetCollision(false,false,false);
      Master.SetDrawType(DT_None);
      Master.bHidden=true;
      }
  }
}

function LoadCharacterTwo()
{
local MSBVoxelCharacterSave char;
local int bone,block;
local MSBMasterBlock Master;

char=Level.Game.LoadDataObject(class'MSBVoxelCharacterSave',content,"MSBVoxChar_"$content);
for(bone=0;bone<char.Parts.length;bone++)
  {
    Master=Blocks[bone];
    //set new blocks
    if (Master!=None)
     for (block=0;block<char.Parts[bone].Col.length;block++)
      {
      //size
      Master.setScale(char.Parts[Bone].drawScale[block],block);
      //color
      Master.setColor(char.Parts[bone].Col[block],block);
      //location
      Master.setParticleLocation(char.Parts[bone].BlockRelLocation[block], block);
      }
  }
}

function setMSBMasterBlocks()
{
local coords C[26];
local int i;

C[0]=GetBoneCoords('Bip01');

C[1]=GetBoneCoords('Bip01 Pelvis');
C[2]=GetBoneCoords('bip01 Spine');
C[3]=GetBoneCoords('bip01 Spine1');
C[4]=GetBoneCoords('bip01 Spine2');
C[5]=GetBoneCoords('Bip01 Neck');

C[6]=GetBoneCoords('Bip01 R Clavicle');
C[7]=GetBoneCoords('Bip01 R UpperArm');
C[8]=GetBoneCoords('Bip01 R Forearm');
C[9]=GetBoneCoords('Bip01 R Hand');
C[10]=GetBoneCoords('Bip01 R Finger');
C[11]=GetBoneCoords('Bone_weapon');

C[12]=GetBoneCoords('Bip01 L Clavicle');
C[13]=GetBoneCoords('Bip01 L UpperArm');
C[14]=GetBoneCoords('Bip01 L Forearm');
C[15]=GetBoneCoords('Bip01 L Hand');
C[16]=GetBoneCoords('Bip01 L Finger');

C[17]=GetBoneCoords('bip01 R Thigh');
C[18]=GetBoneCoords('Bip01 R Calf');
C[19]=GetBoneCoords('Bip01 R Foot');
C[20]=GetBoneCoords('Bip01 R Toe0');

C[21]=GetBoneCoords('bip01 L Thigh');
C[22]=GetBoneCoords('Bip01 L Calf');
C[23]=GetBoneCoords('Bip01 L Foot');
C[24]=GetBoneCoords('Bip01 L Toe0');

C[25]=GetBoneCoords('Bip01 Head');

for (i=0;i<26;i++)
  {
  Blocks[i]=Spawn(class'MSBMasterBlock',self,,C[i].Origin);
  Blocks[i].BoneNumber=i;
  Blocks[i].P=self;
  }
}

function clearPawn()
{
local int i;

for (i=0;i<26;i++)
  {
  Blocks[i].clearBlocks();
  Blocks[i].Destroy();
  if (MSBFaceBlock.length>0)
   if (MSBFaceBlock[i]!=None)
     MSBFaceBlock[i].Destroy();
  }
}

DefaultProperties
{
bSkinSwap=false
bTalkable=false

bCollideActors=true
CollisionHeight=48.0
Skins(0)=Material'MovieSandboxTextures.Transparent'
Skins(1)=Material'MovieSandboxTextures.Transparent'
Skins(2)=Material'MovieSandboxTextures.Transparent'
Skins(3)=Material'MovieSandboxTextures.Transparent'
}
