//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPropertyButtonAttachToBone extends MSBPropertyButton;

var array<String> ButtonList;
var array<String> Properties;
var array<String> ButtonName;
var class<MSBGuiOverlay> ButtonClass;
var array<MSBGuiOverlay> ListButton;
var bool bRelative;

var name BoneName;
var Actor AttachActor;



function LeftBtn(Canvas C)
{
local int i;

super.LeftBtn(C);
LeftBtnFinished(C);

for (i=0;i<Buttonlist.Length; i++)
  {
    ButtonClass = class<MSBGuiOverlay>(DynamicLoadObject(ButtonList[i], class'Class'));
    ListButton[i]=Spawn(ButtonClass);
    ListButton[i].xPos=xpos+width;
    if (i>0)                          //horizontal alignment
      ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+2;
    else
      ListButton[i].yPos=ypos;

    ListButton[i].SubLevel=SubLevel+1;
    ListButton[i].BtnName=ButtonName[i];
    MSBPropertyButton(ListButton[i]).Property=Properties[i];
    MSBPropertyButton(ListButton[i]).Parent=self;
  }
}

function deSelect()                      //destroys all subButtons
{
local int i;
super.deSelect();

for (i=0;i<ListButton.Length;i++)
  {
  ListButton[i].deSelect();
  M.myHUD.RemoveHudOverlay(ListButton[i]);
  ListButton[i].Destroy();
  }
}

function Trigger(Actor Other, Pawn EventInstigator)
{
local vector relLocation;

rellocation=Parent.Location-AttachActor.Location;
AttachActor.AttachToBone(Parent,'');

if (Other==ListButton[0])
  Log("Parent assigned");
if (Other==ListButton[1])
  AttachActor.AttachToBone(Parent,'Bip01 L Hand');
if (Other==ListButton[2])
  AttachActor.AttachToBone(Parent,'Bip01 R Hand');
if (Other==ListButton[3])
  AttachActor.AttachToBone(Parent,'Bip01 Head');
if (Other==ListButton[4])
  AttachActor.AttachToBone(Parent,'bip01 Spine1');
if (Other==ListButton[5])
  AttachActor.AttachToBone(Parent,boneName);

if(bRelative)
  Parent.SetRelativeLocation(relLocation);

if (Parent.IsA('MSBActor'))
  MSBActor(Parent).AttachedTo=AttachActor;
}

DefaultProperties
{
BtnName="Attach"
//Parent
ButtonList(0)="MSBPropertyButtons.MSBPropertyButton3D";
Properties(0)="AttachActor";
ButtonName(0)="Parent";

//LeftHand
ButtonList(1)="MSBPropertyButtons.MSBPropertyButtonAssign";
Properties(1)="BoneName";
ButtonName(1)="LeftHand";

//RightHand
ButtonList(2)="MSBPropertyButtons.MSBPropertyButtonAssign";
Properties(2)="BoneName";
ButtonName(2)="RightHand";

//Head
ButtonList(3)="MSBPropertyButtons.MSBPropertyButtonAssign";
Properties(3)="BoneName";
ButtonName(3)="Head";

//Torso
ButtonList(4)="MSBPropertyButtons.MSBPropertyButtonAssign";
Properties(4)="BoneName";
ButtonName(4)="Torso";

//Custom
ButtonList(5)="MSBPropertyButtons.MSBPropertyButtonText";
Properties(5)="BoneName";
ButtonName(5)="Custom";

//ActorOnly
ButtonList(6)="MSBPropertyButtons.MSBPropertyButtonAssign";
Properties(6)="BoneName";
ButtonName(6)="ActorOnly";

//Relative
ButtonList(7)="MSBPropertyButtons.MSBPropertyButtonBool";
Properties(7)="bRelative";
ButtonName(7)="Relative";

}
