class MSBVoxelEdController extends MSBController;

//voxel related
var MSBDrawBrush DrawBrush;                         //the "Pen"
var MSBRulerPlane Ruler;                            //ruler plane to draw in 3D
var MSBVoxelEdPawn myReferencePawn;                 //reference Character to draw upon

var float drawPosX,drawPosY,oldMouseX,oldMouseY;    //positioning of cursors when drawing

var config color colorfields[8];                    //remember the color in the swatches
var int colorPos;


event PostBeginPlay()
{
super.PostBeginPlay();
//get rid of context buttons
ContextButtonList.remove(0,ContextButtonList.Length);

//set up DrawBrush
initialSetup();

refreshMasters();
}

//creating the pawn, the ruler and the pen and connecting everything together
function initialSetup()
{
local float flGridSpc;

//spawn DrawBrush
DrawBrush=Spawn(class'MSBDrawBrush',self);
flGridSpc=GridSpacing;
drawBrush.SetDrawScale(flGridSpc/8);

//spawn Ruler Plane here!
Ruler=Spawn(class'MSBRulerPlane',self);

//spawn MSBPawn
myReferencePawn=Spawn(class'MSBVoxelEdPawn',self);
myReferencePawn.SetPhysics(PHYS_None);
myReferencePawn.SetRotation(rot(0,0,0));

//move back a little
SetLocation(location+vect(64,0,0));
}

function connectColorSwitches(MSBMenuBrushColorButton mc)
{
mc.col=colorfields[colorPos];
mc.position=colorPos++;
}

//moves the pen when drawing and determines drawing when button down
state CharacterEditor
{
  function PlayerTick(float DeltaTime)
  {
  global.PlayerTick(DeltaTime);
  //2D Positioning
  if (Mouse!=None && !Mouse.bTyping)
   {
    Mouse.xPos+=DeltaTime*MouseSens*aMouseX+aStrafe/6000;
    Mouse.yPos-=DeltaTime*MouseSens*aMouseY+aForward/6000;
   }

  if ((Mouse!=None && Mouse.hudTargetActor!=None) || (Mouse!=None && Mouse.worldMSBTargetActor==None))
    Mouse.bContained=false;
  else if (Mouse!=None)
    {
    Mouse.bContained=true;
    DrawBrush.SetLocation(Mouse.Mouse3D);
    if(!Mouse.bShiftDown && drawBrush.Master!=None)
      {
      drawBrush.Master.Skins[0]=drawBrush.Master.Skins[2];
      determineMaster(DrawBrush.Location);
      drawBrush.Master.Skins[0]=drawBrush.Master.Skins[1];
      }
    if(Mouse.btnOneDown)
      DrawBrush.draw();
    if(Mouse.btnTwoDown)
      DrawBrush.erase();
   }
  }

Begin:
 if (MInteract==None)
   {
   Player.InteractionMaster.AddInteraction("MSBCode.MSBInteraction", Player);
   bHasInteraction=true;
   Mouse=MSBHud(myHud).MouseOverlay;
   MInteract.Mouse=MSBHud(myHud).MouseOverlay;
   Log("PlayerController spawns an Interaction");
   }
determineMaster(DrawBrush.Location);
}


//switches between Drawing and selecting mode
exec function RunMovie();


//switches to flying mode and back
exec function switchStates()
{
bMove=!bMove;
if (bMove)
  GotoState('BaseSpectating');
else
  GotoState('CharacterEditor');
}

function determineMaster(vector loc)
{
if(loc.Z>=27)
 drawBrush.Master=myReferencePawn.Blocks[25];

if(loc.Z<27 && loc.Z>=24)
 drawBrush.Master=myReferencePawn.Blocks[5];

if(loc.Z<24 && loc.Z>=19)
 drawBrush.Master=myReferencePawn.Blocks[4];

if(loc.Z<19 && loc.Z>=13)
 drawBrush.Master=myReferencePawn.Blocks[3];

if(loc.Z<13 && loc.Z>=0)
 drawBrush.Master=myReferencePawn.Blocks[2];

//right leg
if(loc.Z<0 && loc.Z>=-14 && loc.Y>=0)
 drawBrush.Master=myReferencePawn.Blocks[17];

if(loc.Z<-14 && loc.Z>=-36 && loc.Y>=0)
 drawBrush.Master=myReferencePawn.Blocks[18];

 //left leg
if(loc.Z<0 && loc.Z>=-14 && loc.Y<0)
 drawBrush.Master=myReferencePawn.Blocks[21];

if(loc.Z<-14 && loc.Z>=-36 && loc.Y<0)
 drawBrush.Master=myReferencePawn.Blocks[22];


//right Arm
if(loc.Z>24 && loc.Z<27 && loc.Y>1)
 drawBrush.Master=myReferencePawn.Blocks[6];

if(loc.Z>13 && loc.Y>7 && loc.Y<=16)
 drawBrush.Master=myReferencePawn.Blocks[7];

if(loc.Y>16)
 drawBrush.Master=myReferencePawn.Blocks[8];

if(loc.Y>24)
 drawBrush.Master=myReferencePawn.Blocks[9];


//left Arm
if(loc.Z>24 && loc.Z<27 && loc.Y<-1)
 drawBrush.Master=myReferencePawn.Blocks[12];

if(loc.Z>13 && loc.Y<-7 && loc.Y>=-16)
 drawBrush.Master=myReferencePawn.Blocks[13];

if(loc.Y<-16)
 drawBrush.Master=myReferencePawn.Blocks[14];

if(loc.Y<-24)
 drawBrush.Master=myReferencePawn.Blocks[15];
}

exec function refreshMasters()
{
local int i;

for (i=0;i<myReferencePawn.Blocks.length;i++)
  if (myReferencePawn.Blocks[i]!=None)
    myReferencePawn.Blocks[i].SetDrawScale3D(myReferencePawn.Blocks[i].edScale);
}


//left/right MouseButton press override
exec function pressedLeft();
exec function pressedRight();

defaultproperties
{
Gridspacing=2
}
