//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPenWidget extends MSBOpenWidgetButton
config(MSBPenWidget);

var MSBDrawBrush DrawBrush;
var MSBRulerPlane Ruler;

var Actor InputControl;
var int channel;

var bool bMouseControlled;

var config color colorfields[8];                    //remember the color in the swatches
var int colorPos;

function newDrawing(vector loc, optional rotator ro)
{
local float flGridSpc;

//spawn DrawBrush
if(DrawBrush!=None)
  {
  if(DrawBrush.Master!=None)
    {
    DrawBrush.Master.SetCollision(true,true);
    DrawBrush.Master.bHidden=false;
    }
  DrawBrush.Destroy();
  }
DrawBrush=Spawn(class'MSBDrawBrush',self,,loc);
flGridSpc=M.Gridspacing;
drawBrush.SetDrawScale(flGridSpc/8);

//spawn Ruler Plane here!
if(Ruler!=None)
  Ruler.Destroy();
Ruler=Spawn(class'MSBRulerPlane',self,,loc+vect(0,0,32),ro);

//spawn and set up MasterBlock
DrawBrush.Master=Spawn(class'MSBMasterBlock',None,,loc,ro);

M.LevelActors.Insert(M.LevelActors.Length,1);
M.LevelActors[M.LevelActors.Length-1]=DrawBrush.Master;

DrawBrush.Master.SetCollision(false,false);
DrawBrush.Master.bHidden=true;
DrawBrush.Master.P=DrawBrush.Master;
DrawBrush.Master.BoneNumber=-1;
}

function selectedDrawing(MSBMasterBlock block, optional vector loc, optional rotator ro)
{
local float flGridSpc;

//spawn DrawBrush
if(DrawBrush!=None)
  {
  if(DrawBrush.Master!=None)
    {
    DrawBrush.Master.SetCollision(true,true);
    DrawBrush.Master.bHidden=false;
    }
  DrawBrush.Destroy();
  }
DrawBrush=Spawn(class'MSBDrawBrush',self,,loc);
flGridSpc=M.Gridspacing;
drawBrush.SetDrawScale(flGridSpc/8);

//spawn Ruler Plane here!
if(Ruler!=None)
  Ruler.Destroy();
Ruler=Spawn(class'MSBRulerPlane',self,,loc+vect(0,0,32),ro);

//spawn and set up MasterBlock
DrawBrush.Master=block;

DrawBrush.Master.SetCollision(false,false);
DrawBrush.Master.bHidden=true;
DrawBrush.Master.P=DrawBrush.Master;
DrawBrush.Master.BoneNumber=-1;
}

function connectColorSwitches(MSBPenColorButton pc)
{
pc.col=colorfields[colorPos];
pc.position=colorPos++;
}

//moves the pen when drawing and determines drawing when button down
function Render(Canvas C)
{
super.Render(C);

if(bIsOpen && DrawBrush!=None)
  {
    if (Mouse.hudTargetActor==None && Mouse.worldMSBTargetActor==Ruler && bMouseControlled)
      {
      DrawBrush.SetLocation(Mouse.Mouse3D);
      if(Mouse.btnOneDown)
        DrawBrush.draw();
      if(Mouse.btnTwoDown)
        DrawBrush.erase();
      }
  }
}

function Close()
{
if(DrawBrush!=None)
  {
  if(DrawBrush.Master!=None)
    {
    DrawBrush.Master.SetCollision(true,true);
    DrawBrush.Master.bHidden=false;
    }
  DrawBrush.Destroy();
  }

if(Ruler!=None)
  Ruler.Destroy();

colorPos=0;
}

function createButtons()
{
local int i;
super.createButtons();
for (i=liststart;i<listend;i++)
  {
  if(ListButton[i].IsA('MSBPropertyButton'))
    MSBPropertyButton(ListButton[i]).Parent=self;
  }
}

DefaultProperties
{
ButtonList(0)="MSBWidgetPen.MSBNewPenDrawing"
ButtonList(1)="MSBWidgetPen.MSBSelectDrawingButton"
ButtonList(2)="MSBWidgetPen.MSBPenSizeButton"
ButtonList(3)="MSBWidgetPen.MSBPenColorButton"
ButtonList(4)="MSBWidgetPen.MSBPenColorButton"
ButtonList(5)="MSBWidgetPen.MSBPenColorButton"
ButtonList(6)="MSBWidgetPen.MSBPenColorButton"
ButtonList(7)="MSBWidgetPen.MSBLoadDrawingButton"
ButtonList(8)="MSBWidgetPen.MSBSaveDrawingButton"
ButtonList(9)="MSBWidgetPen.MSBPenDrawingChannel"
widgetPosXRel=300
widgetPosYRel=704
listOrientation=2

Mat=Texture'Moviesandboxtextures.icon_brush'

bMouseControlled=true
Col=(R=255,G=64,B=64)
}
